import { BlobClientResponse } from '../client/BlobClientResponse';
import { Client } from '../client/Client';
import { JsonClientResponse } from '../client/JsonClientResponse';
import { ReadableClientResponse } from "../client/ReadableClientResponse";
import { TextClientResponse } from '../client/TextClientResponse';
import { VoidClientResponse } from '../client/VoidClientResponse';
import { StringDictionary } from '../util';
export declare class FetchClient implements Client {
    private _lastActivity;
    getBlob(baseUrl: string, resourcePath?: string): Promise<BlobClientResponse>;
    getText(baseUrl: string, resourcePath?: string): Promise<TextClientResponse>;
    openStream(baseUrl: string, resourcePath?: string): Promise<ReadableClientResponse>;
    postMultipart(baseUrl: string, resourcePath: string, formData: FormData): Promise<VoidClientResponse>;
    getJson(baseUrl: string, resourcePath?: string, queryParams?: StringDictionary): Promise<JsonClientResponse>;
    readonly lastActivity: Date;
    postJson(baseUrl: string, resourcePath: string, jsonBody?: StringDictionary): Promise<JsonClientResponse>;
    putJson(baseUrl: string, resourcePath: string, jsonBody?: StringDictionary): Promise<JsonClientResponse>;
    deleteJson(baseUrl: string, resourcePath: string): Promise<JsonClientResponse>;
    private assertJsonContentType(contentType);
    private encodeQueryParams(queryParams);
    private isJsonContentType(contentType);
    private processRequest(url, method, body?, headers?);
}
